//-----------------------------------------------
declare name "endlessRisset_LP2";
declare version "1.0";
declare author "LP";
declare license "BSD";
declare copyright "(c)ECLLA 2022";

import("stdfaust.lib");

period = hslider("period",120.0 ,0.01,200,0.01):si.smooth(0.96);
ecart = hslider("ecart",0.05 ,0.01,1,0.001):si.smooth(0.96);
moy = hslider("moy",0.5 ,0.0,1,0.001):si.smooth(0.96);
gain = hslider("volume",0.0 ,0.0,1,0.001):si.smooth(0.96);
sens = checkbox("sens");

freq = 1/period;

env = os.lf_sawpos_phase(freq, 0);
env1 = select2(sens, env, (env - 1) * -1);

envi(i) = ((i/10)+env1) % 1.0;
envamp(i) = 2.7^(-1*(((envi(i) - moy) ^ 2)/ ecart));
freqi(i) = ba.midikey2hz(envi(i) * 120.);

synth(n) = par(i, n, os.osc(freqi(i)) * envamp(i)):>_;

process = synth(10)*gain*0.1<:_,_;